from typing import TYPE_CHECKING

from sqlalchemy import Column, ForeignKey, Integer, String, Enum
from sqlalchemy.orm import relationship

from app.db.base_class import Base


if TYPE_CHECKING:
  from .user import User  # noqa: F401
  from .enum import Progress

class Video(Base):
  id = Column(Integer, primary_key=True, index=True)
  title = Column(String, index=True)
  progress = Column(String(20), 
                    ForeignKey("progress.state", ondelete="STRICT", onupdate="STRICT"),
                    defalt="waiting",
                    nullable=False)
  owner_id = Column(Integer, ForeignKey("user.id"))
  owner = relationship("User", back_populates="videos")